//------------------------------------------------------------
#include "RODOS4.h"
#include <iostream>
#include <utility>
//------------------------------------------------------------
bool RODOS4_t::USB_RCCP_WR(uint8_t N, uint8_t REG, uint8_t COM, uint16_t CMD,  uint16_t PRG)
{   //   REG  COM
    USB_BUF_CLEAR();
    USB_BUFO[1] = 0x63;
    USB_BUFO[2] = N;
    USB_BUFO[3] = REG;
    USB_BUFO[4] = COM;
    USB_BUFO[5] = CMD >> 8;
    USB_BUFO[6] = (uint8_t)CMD;
    USB_BUFO[7] = PRG >> 8;
    USB_BUFO[8] = (uint8_t)PRG;
    for (uint8_t TryCount=0; TryCount<3; TryCount++)
        {
         if ( 
              USB_SET_FEATURE() && USB_GET_FEATURE() &&
             (USB_BUFI[1]==0x63) &&
             (USB_BUFI[2]==N)    &&
             (USB_BUFI[3]==REG)  &&
             (USB_BUFI[4]==COM)  &&
             (USB_BUFI[5]==USB_BUFO[5]) && 
             (USB_BUFI[6]==USB_BUFO[6]) &&
             (USB_BUFI[7]==USB_BUFO[7]) &&
             (USB_BUFI[8]==USB_BUFO[8])
            )
            { return true; }
        }
 return false;
}
//------------------------------------------------------------
bool RODOS4_t::USB_RCCP_RD(uint8_t N, uint8_t *REG, uint8_t *COM, uint16_t *CMD, uint16_t *PRG)
{   //   REG, COM, CMD  PRG
    USB_BUF_CLEAR();
    bool RESULT=false;
    USB_BUFO[1]=0x36;
    USB_BUFO[2]=N;
    int i=3;   //   
    for (uint8_t TryCount=0; TryCount<3; TryCount++)
        {
         if (
             USB_SET_FEATURE()   && USB_GET_FEATURE() &&
             (USB_BUFI[1]==0x36) &&
             (USB_BUFI[2]==N)    &&
             (USB_BUFI[1]==0x36) &&
             (USB_BUFI[2]==N)
            )
            {
             *REG=USB_BUFI[3];
             *COM=USB_BUFI[4];
             *CMD=((uint16_t)USB_BUFI[5]<<8) | USB_BUFI[6];
             *PRG=((uint16_t)USB_BUFI[7]<<8) | USB_BUFI[8];
             return true;
            }
        }
 return false;
}
//------------------------------------------------------------
bool RODOS4_t::SET_CHANNEL_PWM(uint8_t ChannelNumber, uint8_t ChannelValue)
{
 return USB_RCCP_WR(ChannelNumber, ChannelValue, 0, 15, 15);
}
//------------------------------------------------------------
